<?php
$current_organizer="file";
require ("../lib-abdesk.php");

CheckCookie();

$errorvarname="compare_sha512_hashes_in_two_DBs_error";

session_start();


require ("../lib-files.php");

function GoBackToFormWithError($err)
{	global $errorvarname, $file_db_to_use;
	$_SESSION[$errorvarname]=$err;
	header("Location: compare_sha512_hashes_in_two_DBs_form.php");
	exit;
}

if ($setphpdefaults)
{
	ini_set("memory_limit", "$phpmem");
	ini_set("max_execution_time", "$phpmaxexec");
	//echo ini_get("memory_limit");
}


	$add=$_POST[add];
	$edited=$_POST[edited];

if (!$add && !$edited)	//Then it was a GET and not a POST
{	

	$db=$_GET[db];
	if ($db)
	{
		$file_db_to_use=$db;
	}
}
else 	// It was a POST after all
{
	$varstoget_fromform=array("radiobox_selected_file_db1", "radiobox_selected_file_db2", "two_way_comparison");

	foreach ($varstoget_fromform as $varname)
		{
			${$varname}=$_POST[$varname];
//In case the user gets sent back to the form, this makes it so their original
//input is preserved:
			$_SESSION[$varname]=$_POST[$varname];
		}
	$file_db_to_use=$radiobox_selected_file_db1;
}

if (!$file_db_to_use)
{	
	GoBackToFormWithError("no db selected");
	exit;
}


#require ("lib-output_folder_structure.php");

$handle=ConnectToDb($file_db_to_use, "dont die");

#list($array_of_unpaired_folder_paths_from_db, $array_of_unpaired_folder_paths_from_db_with_disks, $array_of_disknicks_of_unpaired_folder_paths_from_db, $num_of_paths)=GetUnpairedFolderPathsFromDB($handle);

echo "<html><head><title>ABDesktop $file_db_to_use Compare SHA512 Hashes in Two DBs - </title>
<link rel=stylesheet href=\"css/f.css\" type=\"text/css\">
<style type=\"text/css\"> 
</style></head><body><center>";

AllOrganizerNavLinks();

echo "<h1>ABDesktop File DB - Compare SHA512 Hashes in Two DBs</h1>
<p>";
echo "<big>$file_db_to_use<p>and<p>$radiobox_selected_file_db2</big><p>";


if ( $two_way_comparison)
{
	echo "Doing two-way comparison!";
}
else
{
	echo "Only one-way comparison - making sure the hashes in the first DB are found in the second DB.";
}
#PrintDBHeader("file");

#echo "<p>Num of paths: $num_of_paths";

#$query_to_issue = "SELECT file_id, sha512_hash, binary_sha512_hash from fileinfo where sha512_hash is not null group by sha512_hash having count(*) >= 2 ";

#$query_to_issue = "SELECT file_id, sha512_hash, binary_sha512_hash from fileinfo where sha512_hash is not null and sha512_hash having count(*) >=2 ";



list ( $first_db___sha512_hashes_and_file_ids, $first_db___sha512_hashes, $first_db___counts_of_sha512_hashes) = Get_SHA512_Hashes_and_IDs ( $handle);


function Get_SHA512_Hashes_and_IDs ($handle)
{
	#$query_to_issue = "SELECT file_id, sha512_hash, binary_sha512_hash from fileinfo where sha512_hash is not null";

	$query_to_issue = "SELECT file_id, sha512_hash from fileinfo where sha512_hash is not null";
	
	$query_result=mysql_query($query_to_issue,$handle);

	if ( mysql_error() )
	{
		echo "crap, an error...";
		echo mysql_error();
		die;
	}

	
	$sha512_hashes=array();

	while ($fileinfo = mysql_fetch_array($query_result))
	{	
		$sha512_hash = $fileinfo['sha512_hash'];
		$file_id = $fileinfo['file_id'];
		
		$sha512_hashes_and_file_ids["$sha512_hash"][]=$file_id;
		
		$sha512_hashes[]=$sha512_hash;
		
		$counts_of_sha512_hashes["$sha512_hash"]++;
		#array_push( $sha512_hashes["$sha512_hash"], $file_id);
		
		#$sha512_hashes["$sha512_hash"][]=$file_id;
		
	/*	echo "sha512_hash - ";
		echo $fileinfo['file_id'];
		echo " ";
		echo $fileinfo['sha512_hash'];
		echo "<br>";*/
	}
	
#	PrintArr($sha512_hashes, "SHA512 hashes");
	
	return array($sha512_hashes_and_file_ids, $sha512_hashes, $counts_of_sha512_hashes);
}


#PrintArr($sha512_hashes_and_file_ids);

#PrintArr($sha512_hashes);

#PrintArr($first_db___counts_of_sha512_hashes, "first_db___counts_of_sha512_hashes");

/*
foreach ( $sha512_hashes_and_file_ids as $hash => $file_ids)
{
	foreach ($file_ids as $file_id)
	{
		$sha512_hashes[]=$hash;
	}
}

PrintArr($sha512_hashes);
*/


#$sha512_hashes=array_keys($sha512_hashes_and_file_ids);

#echo " radiobox_selected_file_db2 $radiobox_selected_file_db2";
$file_db_to_use=$radiobox_selected_file_db2;

$handle2=ConnectToDb($file_db_to_use, "dont die");


echo "<p>Count of 1st DB hashes: ";
echo count($first_db___sha512_hashes);


list ( $second_db___sha512_hashes_and_file_ids, $second_db___sha512_hashes, $second_db___counts_of_sha512_hashes) = Get_SHA512_Hashes_and_IDs ( $handle2 );


echo "<p>Count of 2nd DB hashes: ";
echo count($second_db___sha512_hashes);

#PrintArr($second_db___sha512_hashes, "2nd db hashes");



$hashes_not_found_in_second_db = array_diff($first_db___sha512_hashes, $second_db___sha512_hashes);

#PrintArr($hashes_not_found_in_second_db, "Hashes not found in second DB");

if ($two_way_comparison)
{
	echo "<p>Two-way comparison!<p>";

	$hashes_not_found_in_first_db = array_diff($second_db___sha512_hashes, $first_db___sha512_hashes);
	#PrintArr($hashes_not_found_in_first_db, "Hashes not found in first DB");
}


echo "<p><br>";

if (!$hashes_not_found_in_second_db && !$hashes_not_found_in_first_db)
{
	echo "Looks OK, stopping here.";
	die;
}

if ( $hashes_not_found_in_second_db )
{
	echo "<span class='error'>Some hashes from the first DB - $radiobox_selected_file_db1<br>weren't found in the second DB - $radiobox_selected_file_db2!</span>";
}
else
{	echo "<span class='notif'>All hashes from the first DB - $radiobox_selected_file_db1<br>were found in the second DB - $radiobox_selected_file_db2!</span>";

	#PrintArr($first_db___sha512_hashes, "First DB Hashes");
	#PrintArr($second_db___sha512_hashes, "Second DB Hashes");
}
if ($hashes_not_found_in_first_db)
{
	echo "<span class='error'><p>Some hashes from the second DB - $radiobox_selected_file_db2<br>weren't found in the first DB - $radiobox_selected_file_db1!</span>";
}
else
{	
	if ($two_way_comparison)
	{
		echo "<span class='notif'>All hashes from the second DB - $radiobox_selected_file_db2<br>were found in the first DB - $radiobox_selected_file_db1!</span>";
	}
}


if ( $hashes_not_found_in_second_db )
{
	#echo "not found in second db";
	Display_Hash_Comparison($first_db___sha512_hashes_and_file_ids, $first_db___counts_of_sha512_hashes, $second_db___sha512_hashes_and_file_ids, $hashes_not_found_in_second_db, $handle, $radiobox_selected_file_db1, $handle2, $radiobox_selected_file_db2);
}

if ( $hashes_not_found_in_first_db )
{
	#echo "not found in first db";
	Display_Hash_Comparison($second_db___sha512_hashes_and_file_ids, $second_db___counts_of_sha512_hashes, $first_db___sha512_hashes_and_file_ids, $hashes_not_found_in_first_db, $handle2, $radiobox_selected_file_db2, $handle, $radiobox_selected_file_db1);
}


function Display_Hash_Comparison($first_db_hashes_and_file_ids, $first_db_counts_of_hashes, $second_db_hashes_and_file_ids, $hashes_not_found_in_second_db, $first_handle, $first_db, $second_handle, $second_db)
{
	foreach ($hashes_not_found_in_second_db as $hash)
	{
		$counts_of_hashes_not_found_in_second_db["$hash"]++;	
	}
	
	
	$hashes_not_found_in_second_db=array_unique($hashes_not_found_in_second_db);
	
	
	foreach ($hashes_not_found_in_second_db as $hash)
	{
		$first_db___file_ids=$first_db_hashes_and_file_ids["$hash"];
	#	$second_db___file_ids=$second_db_hashes_and_file_ids["$hash"];
		
		foreach ($first_db___file_ids as $file_id)
		{
			$first_db___file_ids_to_get[]=$file_id;
		}
		/*
		if ( $second_db___file_ids )
		{
			foreach ($second_db___file_ids as $file_id)
			{
				$second_db___file_ids_to_get[]=$file_id;
			}
		}*/
	}
	
	if ( $first_db___file_ids_to_get )
	{
		$first_db___files_sorted_by_hash = Get_Files_Sorted_by_Hash_from_DB($first_handle, $first_db, $first_db___file_ids_to_get);
	}
	if ( $second_db___file_ids_to_get )
	{
		$second_db___files_sorted_by_hash = Get_Files_Sorted_by_Hash_from_DB($second_handle, $second_db, $second_db___file_ids_to_get);
	}
	
	
	foreach ($first_db___files_sorted_by_hash as $hash => $files)
	{
		echo "<p><br><hr><p><br>";
		echo "<p>";
		echo "<span class='error'>In $second_db, couldn't find enough files with this hash to match the quantity in $first_db:";
		echo "<p>";
		echo "$hash";
		echo "<p>Quantity needed: ";
		echo $first_db_counts_of_hashes["$hash"];
		echo "<p>Quantity found: ";
		echo $first_db_counts_of_hashes["$hash"] - $counts_of_hashes_not_found_in_second_db["$hash"];
		
		echo "<p><br>These are the files in $first_db which have this hash:";
		
		$varstoget=array("disk", "disknick", "disk", "parentdirs", "filename", "ext", "itemtype", "file_id");
		
		foreach ($files as $file)
		{
			foreach ($varstoget as $var)
			{	
				${$var} = $file["$var"];
			}
			
			echo "<p>";
			
			echo $itemtype;
			
			echo " $file_id: ";
			$path = MakeFilepath($disknick, $disk, $parentdirs, $filename, $ext);
			
			echo $path;
			
		}
		#PrintArr($files);
		
		if ( $second_db___files_sorted_by_hash["$hash"] )
		{
			
			echo "<p><br>These are the files in $second_DB which have this hash:";
			
			PrintArr($second_db___files_sorted_by_hash["$hash"]);
			
			foreach ($first_db___files_sorted_by_hash as $second_db_hash => $second_db_files)
			{
				foreach ($second_db_files as $second_db_file)
				{
					foreach ($varstoget as $var)
					{	
						$var2="$var" . "2";
						
						${$var2} = $file["$var"];
					}
					
					echo "<p>";
					
					echo $itemtype2;
					
					echo " $file_id2: ";
					$path2 = MakeFilepath($disknick2, $disk2, $parentdirs2, $filename2, $ext2);
					
					echo $path2;
					
				}
			}
			
		}
		echo "</span>";
	}
	

}

function Get_Files_Sorted_by_Hash_from_DB($handle, $db, $file_ids_to_get)
{
	global $file_db_to_use;
	
	$comma_separated_file_ids_to_get = implode(", ", $file_ids_to_get);

	if ($comma_separated_file_ids_to_get )
	{
		$query_to_issue = "SELECT file_id, disknick, disk, parentdirs, filename, ext, itemtype, sha512_hash from fileinfo where file_id in ( $comma_separated_file_ids_to_get) ";

		#echo "<p>";
		#echo " query_to_issue - $query_to_issue";
		#echo "<p>";
			
		$file_db_to_use = $db;
		
		SelectDb($db, $handle);

		$query_result=mysql_query($query_to_issue, $handle);

		if ( mysql_error() )
		{
			echo "crap, an error...";
			echo mysql_error();
			die;
		}
		while ($fileinfo = mysql_fetch_array($query_result))
		{	
			#PrintArr($fileinfo);
			
			
			$hash=$fileinfo['sha512_hash'];
			
		#	echo "Hash: $hash ";
			
			$files_sorted_by_hash["$hash"][]=$fileinfo;
		#	$sha512_hash = $fileinfo['sha512_hash'];
		#	$file_id = $fileinfo['file_id'];
			
		#	$sha512_hashes_and_file_ids["$sha512_hash"][]=$file_id;
			
		#	$sha512_hashes[]=$sha512_hash;
			#array_push( $sha512_hashes["$sha512_hash"], $file_id);
			
			#$sha512_hashes["$sha512_hash"][]=$file_id;
			
		#	echo "sha512_hash - ";
			#echo $fileinfo['file_id'];
			#echo " ";
			#echo $fileinfo['sha512_hash'];
			#echo "<br>";
		}
		return $files_sorted_by_hash;
	}
	return false;
}


/*
$first_db___comma_separated_file_ids_to_get = implode(", ", $first_db___file_ids_to_get);

if ( $second_db___file_ids_to_get )
{
	$second_db___comma_separated_file_ids_to_get = implode(", ", $second_db___file_ids_to_get);
}

if ( $second_db___comma_separated_file_ids_to_get )
{
	$query_to_issue = "SELECT file_id, disknick, disk, parentdirs, filename, ext, itemtype, sha512_hash from fileinfo where file_id in ( $second_db___comma_separated_file_ids_to_get) ";

	#echo "<p>";
	#echo " query_to_issue - $query_to_issue";
	#echo "<p>";

	$query_result=mysql_query($query_to_issue, $handle);

	if ( mysql_error() )
	{
		echo "crap, an error...";
		mysql_error();
		die;
	}
	while ($fileinfo = mysql_fetch_array($query_result))
	{	
		#PrintArr($fileinfo);
		
		
		$hash=$fileinfo['sha512_hash'];
		
	#	echo "Hash: $hash ";
		
		$second_db___files_sorted_by_hash["$hash"][]=$fileinfo;
	#	$sha512_hash = $fileinfo['sha512_hash'];
	#	$file_id = $fileinfo['file_id'];
		
	#	$sha512_hashes_and_file_ids["$sha512_hash"][]=$file_id;
		
	#	$sha512_hashes[]=$sha512_hash;
		#array_push( $sha512_hashes["$sha512_hash"], $file_id);
		
		#$sha512_hashes["$sha512_hash"][]=$file_id;
		
	#	echo "sha512_hash - ";
		#echo $fileinfo['file_id'];
		#echo " ";
		#echo $fileinfo['sha512_hash'];
		#echo "<br>";
	}

}


*/

/*
if ( $hashes_not_found_in_second_db)
{
	foreach ($hashes_not_found_in_second_db as $hash)
	{
		$counts_of_hashes_not_found_in_second_db["$hash"]++;	
	}
}

if ( $hashes_not_found_in_first_db )
{
	foreach ($hashes_not_found_in_first_db as $hash)
	{
		$counts_of_hashes_not_found_in_first_db["$hash"]++;	
	}
}
*/


#PrintArr($counts_of_hashes_not_found_in_second_db, "counts_of_hashes_not_found_in_second_db");







#$query_to_issue = "SELECT * from fileinfo where file_id in ( $comma_separated_file_ids_to_get)";


/*
$file_db_to_use = $radiobox_selected_file_db1;
SelectDb($file_db_to_use, $handle);

$query_to_issue = "SELECT file_id, disknick, disk, parentdirs, filename, ext, itemtype, sha512_hash from fileinfo where file_id in ( $first_db___comma_separated_file_ids_to_get) ";

#echo "<p>";
#echo " query_to_issue - $query_to_issue";
#echo "<p>";

$query_result=mysql_query($query_to_issue, $handle);

if ( mysql_error() )
{
	echo "crap, an error...";
	mysql_error();
	die;
}


while ($fileinfo = mysql_fetch_array($query_result))
{	
	#PrintArr($fileinfo);
	
	
	$hash=$fileinfo['sha512_hash'];
	
#	echo "Hash: $hash ";
	
	$first_db___files_sorted_by_hash["$hash"][]=$fileinfo;
#	$sha512_hash = $fileinfo['sha512_hash'];
#	$file_id = $fileinfo['file_id'];
	
#	$sha512_hashes_and_file_ids["$sha512_hash"][]=$file_id;
	
#	$sha512_hashes[]=$sha512_hash;
	#array_push( $sha512_hashes["$sha512_hash"], $file_id);
	
	#$sha512_hashes["$sha512_hash"][]=$file_id;
	
#	echo "sha512_hash - ";
	#echo $fileinfo['file_id'];
	#echo " ";
	#echo $fileinfo['sha512_hash'];
	#echo "<br>";
}
*/



#echo "<pre>";
#PrintArr($files_sorted_by_hash, "files_sorted_by_hash");

/*
foreach ($first_db___files_sorted_by_hash as $hash => $files)
{
	echo "<p><br><hr><p><br>";
	echo "<p>";
	echo "In second DB - $radiobox_selected_file_db2 - couldn't find enough files with this hash to match the quantity in the first DB - $radiobox_selected_file_db1:";
	echo "<p>";
	echo "$hash";
	echo "<p>Quantity needed: ";
	echo $first_db___counts_of_sha512_hashes["$hash"];
	echo "<p>Quantity found: ";
	echo $first_db___counts_of_sha512_hashes["$hash"] - $counts_of_hashes_not_found_in_second_db["$hash"];
	
	echo "<p><br>These are the files in the first DB - $radiobox_selected_file_db1 - which have this hash:";
	
	$varstoget=array("disk", "disknick", "disk", "parentdirs", "filename", "ext", "itemtype", "file_id");
	
	foreach ($files as $file)
	{
		foreach ($varstoget as $var)
		{	
			${$var} = $file["$var"];
		}
		
		echo "<p>";
		
		echo $itemtype;
		
		echo " $file_id: ";
		$path = MakeFilepath($disknick, $disk, $parentdirs, $filename, $ext);
		
		echo $path;
		
	}
	#PrintArr($files);
	
	if ( $second_db___files_sorted_by_hash["$hash"] )
	{
		echo "<p><br>These are the files in the second DB - $radiobox_selected_file_db2 - which have this hash:";
	
		PrintArr($second_db___files_sorted_by_hash["$hash"]);
	}
}
*/

#PrintArr($file_ids_to_get, "file ids to get");


#echo "file_ids_to_get - $file_ids_to_get";

die;

/*
$query_result=mysql_query($query_to_issue,$handle);

if ( mysql_error() )
{
	echo "crap, an error...";
	mysql_error();
	die;
}


while ($fileinfo = mysql_fetch_array($query_result))
{	
	$sha512_hash = $fileinfo['sha512_hash'];
	$file_id = $fileinfo['file_id'];
	
	$second_db___sha512_hashes_and_file_ids["$sha512_hash"][]=$file_id;
	
	#array_push( $sha512_hashes["$sha512_hash"], $file_id);
	
	#$sha512_hashes["$sha512_hash"][]=$file_id;
	
#	echo "sha512_hash - ";
	#echo $fileinfo['file_id'];
	#echo " ";
	#echo $fileinfo['sha512_hash'];
	#echo "<br>";
}

$second_db___sha512_hashes=array_keys($second_db___sha512_hashes_and_file_ids);




PrintArr($second_db___sha512_hashes);
*/
			
die;
/*PrintArr($array_of_unpaired_folder_paths_from_db);
PrintArr($array_of_unpaired_folder_paths_from_db_with_disks);
PrintArr($array_of_disknicks_of_unpaired_folder_paths_from_db);
*/

echo "</center>";

$pathnum=0;
$prev_path="//";
$link_label=null;
$link_url=null;
$prev_num_of_path_parts=0;

$num_of_paths=count($array_of_unpaired_folder_paths_from_db);
//echo "<pre>";
//PrintArr($array_of_disknicks_of_unpaired_folder_paths_from_db);
//PrintArr($array_of_unpaired_folder_paths_from_db);
while ($pathnum<$num_of_paths)
{
	$this_path=$array_of_unpaired_folder_paths_from_db[$pathnum];
	$link_class="";
	
	echo "This path: $this_path<br>";
	
	if ($this_path=="")
	{
		$link_url="file://localhost/" . $array_of_unpaired_folder_paths_from_db_with_disks[$pathnum];
		$link_label=$array_of_unpaired_folder_paths_from_db_with_disks[$pathnum];
		//echo "Link label: '$link_label' ";
		$num_of_path_parts=1;
	}
	else
	{
		$exploded_path=explode("/", $this_path);
		$num_of_path_parts=count($exploded_path);
		//PrintArr($exploded_path, "$this_path");
	//	echo "Num of path parts: $num_of_path_parts";
		$link_url="file://localhost/" . $array_of_unpaired_folder_paths_from_db_with_disks[$pathnum];
		$link_label=$exploded_path[$num_of_path_parts-1];
	}
	
	if ($num_of_path_parts>$prev_num_of_path_parts)
	{	$repeat_count=$num_of_path_parts-$prev_num_of_path_parts;
	//	echo str_repeat("<ul>ul", $repeat_count);
		echo str_repeat("<ul>", $repeat_count);
	}
	else if ($num_of_path_parts<$prev_num_of_path_parts)
	{	$repeat_count=$prev_num_of_path_parts-$num_of_path_parts;
		echo str_repeat("</ul>", $repeat_count);
		//echo str_repeat("</ul>/ul", $repeat_count);
	}
	
	if ($this_path!=$prev_path)
	{
		//echo "<li>$link_label";
		$raw_url_encoded_path=rawurlencode($this_path);
		echo "\n\n<li><big><a href=\"make_solamnia_folders.php?dir=$raw_url_encoded_path&disk=S\">$link_label</a></big>";
		
	}
	
	//else if ($this_path==$prev_path)
	//{	//echo "This path: '$this_path' Prev path: '$prev_path' ";
		$link_label=$array_of_disknicks_of_unpaired_folder_paths_from_db[$pathnum];
		$link_class="class='altdisknick'";
		//echo " <small>(";
//	}
	
	echo " - <a $link_class href='$link_url'>$link_label</a>";
	
	/*if ($this_path==$prev_path)
	{
		echo ")</small>";
	}*/
	$prev_path=$this_path;
	$prev_num_of_path_parts=$num_of_path_parts;
	$pathnum++;
}

$repeat_count=$num_of_path_parts;
echo str_repeat("</ul>", $repeat_count);

echo "<center>";
AllOrganizerNavLinks();
