<?php


function Echo_Hyperlink_for_Disknick($disknick, $label, $path="")
{
	$result = Get_Hyperlink_for_Disknick($disknick, $label, $path);
	echo $result;
	
}

function Get_Hyperlink_for_Disknick($disknick, $label, $path="")
{	global $disk_aliases;

	//echo "disknick: $disknick ";
	$hyperlink_uri = "file://localhost/" . key($disk_aliases[$disknick]) . ":/" . $path;
	
	$result = "<a name=\"$path\"></a><a href='$hyperlink_uri'>$label</a>";
	
	
	return $result;
}

function Get_Path_with_Last_Folder_Highlighted($path)
{
	$fragmentized_path=explode("/", $path);
	
	$last_folder=array_pop($fragmentized_path);
	
	$reglued_path=implode("/", $fragmentized_path);
	
	$reglued_path = "<big><b><code>" . $reglued_path . "/</code>" . "<br>$last_folder</b></big>";
	
	return $reglued_path;
	
}

function Get_Last_Folder_from_Path($path)
{
	$fragmentized_path=explode("/", $path);
	
	$last_folder=end($fragmentized_path);
	
	//$last_folder = "<b>" . $last_folder . "</b>";

	//echo "* func ";
	//	echo "<li>"; 
	//	echo $hyperlink_label;*/
//	return $path;
	return $last_folder;
}




function Output_Folder_Structure($paths_and_disknicks)
{
	global $disk_aliases;
	
	$prev_count_of_slashes_in_path=0;
		
	foreach($paths_and_disknicks as $path => $disknicks)
	{
		//echo "<li>";
		if (!$path)
		{	// 11:41:20 3/3/2014. Then, root level of a disk.
			//echo "EEK";
			$result = "<center>";
			//Disknicks present in DB:<p>";
			foreach ($disknicks as $disknick)
			{	echo "Disknick: $disknick ";
				//$hyperlink_label=key($disk_aliases[$disknick]);
				//$hyperlink_label = "$disknick &nbsp; " . key($disk_aliases[$disknick]) . ":/";
				
				$result .= Get_Hyperlink_for_Disknick($disknick, "$disknick&nbsp;&nbsp;&nbsp;" . key($disk_aliases[$disknick]) . ":/" );
				
				$result .= "&nbsp;";
				$result .= Get_File_Lister_Browse_Folder_Link($disknick, key($disk_aliases[$disknick]), true);
				$result .= "&nbsp;";
				$result .= Get_File_Lister_Browse_Folder_Link($disknick, dirname(key($disk_aliases[$disknick]) ), true);
				
				$result .=  " &nbsp;&nbsp;&nbsp;&nbsp;  &nbsp;&nbsp;&nbsp;&nbsp; ";
	
				//$hyperlink_label );
				
			//	$hyperlink_uri = "file://localhost/" . key($disk_aliases[$disknick]) . ":/";
			//	$hyperlink_label=current($disk_aliases[$disknick]);
				
			}
			$result .= "</center>";
			$result .= "<ul>";
			continue;
		}
		$count_of_slashes_in_path = substr_count($path, "/");
		
		//echo " count: $count_of_slashes_in_path $prev_count_of_slashes_in_path $path ";
		
		if ($count_of_slashes_in_path>=$prev_count_of_slashes_in_path)
		{
			$num_of_uls_to_make=$count_of_slashes_in_path-$prev_count_of_slashes_in_path;
			$result .= str_repeat("<ul>", $num_of_uls_to_make);
				
			
		}
		else if ($count_of_slashes_in_path<$prev_count_of_slashes_in_path)
		{	$num_of_uls_to_close=$prev_count_of_slashes_in_path-$count_of_slashes_in_path;
			$result .= str_repeat("</ul>", $num_of_uls_to_close);
		
		}
		

		$result .= "<li>";
		
		
		
		if ($count_of_slashes_in_path<$prev_count_of_slashes_in_path )
		{	$slashes_less_than_prev_count = $prev_count_of_slashes_in_path - $count_of_slashes_in_path;
			if ( $slashes_less_than_prev_count > 1)
			{	//$path;
				$string_to_print = Get_Path_with_Last_Folder_Highlighted($path);
				//$string_to_print = Get_Last_Folder_from_Path($path);
			}
			else
			{	$string_to_print = Get_Last_Folder_from_Path($path);
			#	$string_to_print="<b>$string_to_print</b>";
			}
		}
		if ($count_of_slashes_in_path>=$prev_count_of_slashes_in_path)
		{	
			$string_to_print = Get_Last_Folder_from_Path($path);
			
		}
		//echo "<table><tr><td>";
		$result .= $string_to_print;
		$result .= " &nbsp;&nbsp; ";
		
		
		foreach ($disknicks as $disknick)
		{
			$result .= Get_Hyperlink_for_Disknick($disknick, $disknick, $path);
			
			$result .= "&nbsp;";
			$result .= Get_File_Lister_Browse_Folder_Link($disknick, $path, true);
			$result .= "&nbsp;";
			$result .= Get_File_Lister_Browse_Folder_Link($disknick, dirname($path) , false, "", "Parent");
		}
		//echo "</table>";
		
		/*		$fragmentized_path=explode("/", $path);
		
			$hyperlink_label=end($fragmentized_path);
			
			echo "<li>"; 
			echo $hyperlink_label;*/
			
		
		$prev_count_of_slashes_in_path=$count_of_slashes_in_path;
	}

	$num_of_uls_to_close=$prev_count_of_slashes_in_path;
	$result .= str_repeat("</ul>", $num_of_uls_to_close);
	$result .= "</ul>";


	$result .= "</ul>";
	
	return $result;
}


function Get_All_Disknicks_and_Paths_from_DB_and_Make_List_of_Paths_and_Disknicks($handle, $should_include_files=false, $extra_where_querystuff="", $start=false, $limit=false, $should_ignore_parentdirs_of_files=false)
{
	
	
	if (!$limit)
	{	$limit=9999999999;
	}
	if (!$start)
	{
		$start=0;
	}
	$limit_querystuff="LIMIT $start, $limit";
	
	$query = "select concat(parentdirs, '/', filename) as path, disknick from fileinfo where itemtype='Dir' and paired='n' and deleted='n' $extra_where_querystuff order by path ASC, disknick ASC $limit_querystuff";
	
	echo "First query: $query<p>";
	
	$disknicks_and_folderpaths=Get_Disknicks_and_Folderpaths_from_DB($handle, $query, $disknicks_and_folderpaths);
	
	
	
	if ($should_include_files)
	{
		$query = "select 
		concat( coalesce(parentdirs, ''), 
		if (length(parentdirs), '/', ''), 
		coalesce(filename,''), 
		if (length(ext), '.', ''),
		coalesce(ext,'') ) as path, disknick from fileinfo where itemtype='File' and deleted='n' $extra_where_querystuff group by path order by path ASC, disknick ASC $limit_querystuff";
		
		echo "Query: $query";
		
		$disknicks_and_folderpaths=Get_Disknicks_and_Folderpaths_from_DB($handle, $query, $disknicks_and_folderpaths);
		
		#PrintArr($disknicks_and_folderpaths);
		
		#$disknicks_and_folderpaths=Get_Disknicks_and_Folderpaths_from_DB($handle, "select concat(parentdirs, '/', filename) as path, disknick from fileinfo where itemtype='File' and deleted='n' $extra_where_querystuff group by path order by path ASC, disknick ASC", $disknicks_and_folderpaths);
		
		#$disknicks_and_folderpaths=Get_Disknicks_and_Folderpaths_from_DB($handle, "select concat_ws('/', parentdirs, filename) as partialpath, concat_ws('.', partialpath, ext) as path, disknick from fileinfo where itemtype='File' and deleted='n' $extra_where_querystuff group by path order by path ASC, disknick ASC", $disknicks_and_folderpaths);
	
	}
	else
	{	
		if (!$should_ignore_parentdirs_of_files)
		{
			$query = "select parentdirs as path, disknick from fileinfo where itemtype='File' and deleted='n' $extra_where_querystuff group by path order by path ASC, disknick ASC $limit_querystuff";
		
			echo "Query: $query";
		
			$disknicks_and_folderpaths=Get_Disknicks_and_Folderpaths_from_DB($handle, $query, $disknicks_and_folderpaths);
		}
		
		
	}
	

	
//	$disknicks_and_folderpaths=array_merge($dir_disknicks_and_folderpaths, $file_disknicks_and_folderpaths);
	
	list($disknicks_and_folderpaths, $paths_with_x_folders)=Fragmentize_Folderpaths($disknicks_and_folderpaths);
	
//	echo "<pre>";
//	PrintArr($paths_with_x_folders);
	
	uksort($disknicks_and_folderpaths, 'strnatcmp');
		// 10:42:05 3/3/2014.  To sort the disknicks in natural order.
		
	$paths_and_disknicks=Make_List_of_Paths_and_Disknicks($disknicks_and_folderpaths);
	
	//echo "<pre>";
	//PrintArr($disknicks_and_folderpaths);
	//PrintArr($paths_and_disknicks);
	return $paths_and_disknicks;
}

function Make_List_of_Paths_and_Disknicks($disknicks_and_folderpaths)
{
	$paths_and_disknicks=array();
	
	// 10:27:43 3/3/2014.  First, need to built an array of paths, with the paths as the values
	// instead of keys, 
	
	foreach ($disknicks_and_folderpaths as $disknick => $path_array)
	{
		foreach ($path_array as $path)
		{
			if (!isset($paths_and_disknicks[$path]) )
			{	$paths_and_disknicks[$path]=array();
			}
			array_push($paths_and_disknicks[$path], $disknick);
		}
	}
	//ksort($paths_and_disknicks, SORT_NATURAL);
	uksort($paths_and_disknicks, 'strnatcmp');
		// 10:42:28 3/3/2014. To sort the paths in natural order.
		
	return $paths_and_disknicks;
	
}

function Fragmentize_Folderpaths($disknicks_and_folderpaths)
{
	$paths_with_x_folders=array();
	
	foreach ($disknicks_and_folderpaths as $disknick => $path_array)
	{	//$array_of_paths=$path_array;
		
		//PrintArr($array_of_paths);
		foreach ($path_array as $path)
		{	$fragmentized_path = explode("/", $path);
			
			//echo "<pre>";
			$count = count($path_array);
			//echo "Count of path array: $count ";
			
			//PrintArr($fragmentized_path);
			
			$count_of_path_fragments=count($fragmentized_path);
			
		//	echo "Count: $count_of_path_fragments $path<br>";
			
		//	if ($count_of_path_fragments==1)
		//	{	array_push($paths_with_one_folder, $path);
				//continue;
			
		//	}
			$arrin_of_current_path_fragment=0;
			$rebuilt_path="";
			
			array_push($disknicks_and_folderpaths[$disknick], $rebuilt_path);
				// 9:46:21 3/3/2014. Always want the root level of the disk listed, even if it's not abdesked.
				
			while ($arrin_of_current_path_fragment < $count_of_path_fragments)
			{	
				//$arrin_of_next_path_fragment=$arrin_of_current_path_fragment+1;
				
			//	echo " arrin of : " . $fragmentized_path[$arrin_of_current_path_fragment];
				
				
				
				$rebuilt_path = $rebuilt_path . "/" . $fragmentized_path[$arrin_of_current_path_fragment];
								
				if ($arrin_of_current_path_fragment==0)
				{	
					$rebuilt_path=ltrim($rebuilt_path, "/");
					//$count_of_slashes_in_path = substr_count($rebuilt_path, "/");	
				//	echo "<br>count_of_slashes_in_path: $count_of_slashes_in_path $rebuilt_path  ";
					//if ($count_of_slashes_in_path==0)
				//	{	//echo "BINGO! $rebuilt_path<p>";
					//	if (!isset($paths_with_x_folders[0]) )
					//	{	$paths_with_x_folders[0]=array();
					//	}
					//	array_push($paths_with_x_folders[0], $rebuilt_path);
					//	PrintArr($paths_with_one_folder);
					//}
				}
				
				
				
				$count_of_slashes_in_path = substr_count($rebuilt_path, "/");
				
				if (!isset($paths_with_x_folders[$count_of_slashes_in_path]) )
				{	$paths_with_x_folders[$count_of_slashes_in_path]=array();
					
					
				}
				array_push($paths_with_x_folders[$count_of_slashes_in_path], $rebuilt_path);
				
				array_push($disknicks_and_folderpaths[$disknick], $rebuilt_path);
					
				
				$arrin_of_current_path_fragment++;
				
			}
		
		}
		$disknicks_and_folderpaths[$disknick]=array_unique($disknicks_and_folderpaths[$disknick]);
		
		//natcasesort($disknicks_and_folderpaths[$disknick]);
		$disknicks_and_folderpaths[$disknick] = array_merge($disknicks_and_folderpaths[$disknick]);
		
	}
	
	$count_of_paths_with_x_folders = count($paths_with_x_folders);
	
	$arrin_of_path_with_x_folders = 0;
	while ($arrin_of_path_with_x_folders<$count_of_paths_with_x_folders)
	{	
		$paths_with_x_folders[$arrin_of_path_with_x_folders]=array_unique($paths_with_x_folders[$arrin_of_path_with_x_folders]);
		
		$paths_with_x_folders[$arrin_of_path_with_x_folders]=array_merge( $paths_with_x_folders[$arrin_of_path_with_x_folders] );
		
		natcasesort($paths_with_x_folders[$arrin_of_path_with_x_folders]);
		$arrin_of_path_with_x_folders++;
	}
	
/*	$paths_with_one_folder=array_unique($paths_with_one_folder);
	$paths_with_one_folder=array_merge($paths_with_one_folder);
	natcasesort($paths_with_one_folder);*/
	
	return array ($disknicks_and_folderpaths, $paths_with_x_folders);
}

function Get_Disknicks_and_Folderpaths_from_DB($handle, $query_to_issue, $disknicks_and_folderpaths)
{
	$query_result = mysql_query($query_to_issue,$handle) or die(mysql_error($handle));
	
	$numofrecords=mysql_numrows($query_result);
	
	if ($numofrecords>0)
	{
		while ($fileinfo = mysql_fetch_array($query_result) ) 
		{	
			$disknick=$fileinfo['disknick'];
			$path=$fileinfo['path'];
		
		#	echo "<p>Path: $path";
			
			if (!isset($disknicks_and_folderpaths[$disknick]) )
			{
				$disknicks_and_folderpaths[$disknick]=array();
			}
			array_push($disknicks_and_folderpaths[$disknick], $path);
			
		}
		//echo "<pre>";	
		
		return $disknicks_and_folderpaths;
	}
}

