<?php
require ("lib-abdesk.php");
CheckCookie();


function UpDown_Navigation($up_dest, $down_dest)
{
	echo "<div class='navanchs'><a href='#top' class='updown'>&#x25B2;&nbsp;Top</a>&nbsp;&nbsp;<a href='#bottom' class='updown'>&#x25BC;&nbsp;Bottom</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href='#$down_dest' class='updown'>&#x2193;&nbsp;Down</a>&nbsp;&nbsp;&nbsp;<a href='#$up_dest' class='updown'>Up&nbsp;&#x2191;</a></div>";
	
}
?>
<html><head><title>ABDesktop Main Page</title></html>
<link rel=stylesheet href="files/css/f.css" type="text/css"></head>
<body><center><p><a name="top_updown_nav"></a>
<?php 

#UpDown_Navigation("top", "list_of_file_dbs");

UpDown_Navigation("top", "list_of_url_dbs");

AllOrganizerNavLinks();
?>
<p>
<h1>ABDesktop v<?php echo $abdesktop_version?></h1></center>


<a name="2nd_updown_nav"></a>
<?php 

#UpDown_Navigation("top_updown_nav", "list_of_file_dbs");
?>
<p>


<div class="navlinks">
<?php

if ($platform_mode=="Linux")
{
?>
<a href="http://localhost/phpMyAdmin/">phpMyAdmin</a> - 
<?php
}
else if ($platform_mode=="Windows")
{
?>
<a href="http://localhost/phpmyadmin">phpMyAdmin</a> - 
<?php
}?>
<a href="abdesk-dangerous/backup_recent_form.php">Backup Recently Modified Records</a>
<?php
if ($platform_mode=="Linux")
{	
?>
- <a href="abdesk-dangerous/grant-db-powers-form.php">Grant DB Powers</a>
<?php
}?>
<p>

<b>Manuals:</b> <a href="urls/manual_of_search_commands_etc-urls.php">URL Organizer</a> - <a href="ideas/manual_of_search_commands_etc-ideas.php">Idea Organizer</a> - <a href="files/manual_of_search_commands_etc-files.php">File Organizer</a> 
<p>
<a href="00-readme--start-here.html">Readme</a>
<p>
<b><a href="01uncommon.php">Uncommonly-Used Functions</a></b>
</div>

<p>
<center>
<big>
<?php

if ($autodetecting_platform)
{
	echo "Detected Platform:";
}
else
{	echo "User-Specified Platform:";
}
echo " $platform_mode<p>";

?>
</big>


Please don't edit records in ABDesktop using more than one web browser, since that can create problems related to the search tags and session variables.<br>(Browsing things in more than one web browser is probably fine.)

<?php

echo "<p><a name='list_of_url_dbs'></a>";
UpDown_Navigation("top_updown_nav", "list_of_idea_dbs");

PrintDBsList("url", true, true, "lister");
echo "<br clear=all>";

echo "<p><a name='list_of_idea_dbs'></a>";

UpDown_Navigation("list_of_url_dbs", "list_of_file_dbs");

PrintDBsList("idea", true, true, "lister");
echo "<br clear=all>";

echo "<p><a name='list_of_file_dbs'></a>";

#UpDown_Navigation("top_updown_nav", "after_list_of_file_dbs");
UpDown_Navigation("list_of_idea_dbs", "after_list_of_file_dbs");

PrintDBsList("file", true, true, "lister");
#echo "<p>";
#Print_Links_for_DB_Folder_Structure("file");


?>

<p>
<a name="after_list_of_file_dbs"></a>
<?php UpDown_Navigation("list_of_file_dbs", "apollia_note");
?>
<br><br>
<div class="navlinks">

<a href="sessionvars-show.php">Show Session Variables</a>
<p>
<a href="files/not-in-abdesk-3_0/output_folder_structure_form.php">Output Folder Structure</a>
<p>
<a a href="files/compare_sha512_hashes_in_two_DBs_form.php">Compare SHA512 Hashes in Two DBs</a>
<p>
<br>
<? #<p>
# <a href="files/output_folder_structure_form.php">Output Folder Structure</a>
#<p>
#<a href="files/output_folder_structure_form-orig.php">Output Folder Structure (Orig)</a>
?>
</div>


<a name="apollia_note"></a>
<?php
UpDown_Navigation("after_list_of_file_dbs", "bottom");
?>
<table width=75% border><tr><td>
<center><big>Note by Apollia - Feb. 6, 2015<p>
(Note, Sept. 19, 2015, 7:30 PM: The below, though it was written about Astroblahhh Desktop 2.0,<br>also applies to Astroblahhh Desktop 2.3.)</big></center>
<p>
<blockquote>Though <a href="http://astroblahhh.com/software/abdesktop">Astroblahhh Desktop 2.0</a> works astonishingly well for many things, its code is terribly messy, and it is far less advanced than Astroblahhh Desktop 3.0 - which, as I write this, is incomplete and not yet released.
<p>
In many ways, ABDesktop 2.0 is a good example of how <i>not</i> to code.  Also, the documentation isn't even close to fully updated, so there are many new features and commands that aren't explained at all in the manuals.
<p>
Nonetheless, ABDesktop 2.0 has served me well for years, and it has seemed pretty stable too.  So, despite its imperfections, I decided to release it anyway.
<p>
<br>
<b>Please be cautious with Astroblahhh Desktop - please only use it at your own risk, and please don't trust it too much, in case it has catastrophic glitches that I'm unaware of.
<p>
Also, if you're interested in modifying ABDesktop, you might be better off waiting for ABDesktop 3.0, which is already tremendously better, even though it's not yet releasable.
<p>
<br>
I haven't lately tested the scripts which upgrade databases from previous versions of ABDesktop, so, I don't know what will happen if you run them.
<p>
So, the database upgrade scripts are now on the <? #<a href="http://localhost/abdesk/abdesk-dangerous/01dangerous.php">?>Dangerous Functions</a> page instead of their original location, the <a href="http://localhost/abdesk/01uncommon.php">Uncommonly-Used Functions</a> page.
</b>
<p>
<br>
ABDesktop 3.0 will most likely have features to make the transition from ABDesktop 2.0 to 3.0 as smooth and easy as possible, because I have a lot of ABDesktop 2.0 databases of my own that I'm going to have to convert.
<p>
As far as I know, I might be the only serious user of ABDesktop in the world.  So, I'm not sure I'm going to devote very much time and energy to making it possible to upgrade ABDesktop databases below version 2.0, unless someone actually needs that.
<p>
<br>
Feedback, questions, discussions, etc. are welcome, and you can post them publicly at the official <a href="http://eryss.com/forum/astroblahhh-desktop">Astroblahhh Desktop board</a> at the <a href="http://eryss.com/forum">Eryss.Com Forum</a>, or send them to me <a href="http://astroblahhh.com/contact-apollia.shtml">privately</a>.
<p>
I also welcome <a href="http://astroblahhh.com/donations.shtml">donations, microdonations</a>, and purchases of <a href="http://astroblahhh.com/goods.shtml">goods</a> and <a href="http://astroblahhh.com/services.shtml">services</a>. 
</blockquote>

<p>

</center>
</table>

<p>


</big></b>
<p> 
<br>
<hr width=75%>
<p>
<center><a name="bottom"></a>
<?php 

UpDown_Navigation("apollia_note", "bottom");

AllOrganizerNavLinks(); ?></body></html>