<?php

function MakeLidSequence($start_id, $num_of_items)
{	global $checkedlids;

	$end_id=$start_id+$num_of_items;
	$x=$start_id;
	$checkedlids=array();
	while ($x<$end_id)
	{	array_push($checkedlids, $x);
		
		$x++;
	}
}

function ExecuteMassEdit($typeofmassedit="fb", $start_id=0, $num_of_items=0)
{	global $handle, $url_db_to_use, $error, $warning, $notif, $tags_changed, $arr_lids, $affected_tables, $checkedlids, $dbtags, $tag_itemids, $queries_issued, $tqueries_issued, $editquery, $arr_needed_tagstrings, $editquery_part2, $needed_tagstrings, $editortempopen, $making_delete_queries, $editedlids, $movepath, $catnames_and_nums, $affecteditems, $editqueriesissued, $url_organizer__allows_allresults_mass_edit_command, $tagmapquery_part, $nowtimestamp, $customsqlquery, $dont_update_whenmodified;

	$nowtimestamp=GetNowTimestamp();
	$nowtimestamp=EncloseOrNull($nowtimestamp, "'");
	
	$queries_issued="";
	if (!$affecteditems)
	{
		$affecteditems="checkeditems";
	}
	if ($typeofmassedit=="fb")
	{
		$editquery=$_POST[editquery];
		if (!$editquery)
		{	$error="no edit query";
			return false;
		}
	}
	if ($typeofmassedit=="fb" || $typeofmassedit=="lister")
	{	
		$editquery_part2=ParseEditQuery($editquery);
	}
	//echo "editquery_part2: $editquery_part2 ";
	$affected_tables=array_unique($affected_tables);

	if ($typeofmassedit!="adder")
	{
		GetCheckedLids();
	}
	else
	{	MakeLidSequence($start_id, $num_of_items);
	}
	
	//Adder - automatically affects all results, but uses "checkeditems"
		//with an array generated containing all ids...
	//Lister - a choice between checked, page, and all results.
	//File browser - all and page amount to the same thing, but,
		//we don't want to encourage the user to use the all command
		//too blithely, so, we toss the user a warning if they use all.
		//If either command is used, affecteditems changed to thispageonly so it reads the 
		//lids posted by the filebrowser rather than asking the db.
	
	switch ($typeofmassedit)
	{	case "lister": break;

		case "adder": 
			if ($affected_items=="thispageonly" || $affecteditems=="allresults")
			{
				$warning="page and allresults commands not needed";
			}
			$affecteditems="checkeditems";
			break;

		case "fb": 
			
			if ($affecteditems=="thispageonly")
			{	if (!$allow_page_mass_edit_command_in_fb)
				{	$dontexecutequery=true;
					$error="page command currently forbidden in fb";
					return false;
				}
				$warning="remem to delete thispageonly command";
				
				$affecteditems="thispageonly";
			} 
			else if ($affecteditems=="allresults")
			{
				$warning="allresults command discouraged";
				
				$affecteditems="thispageonly";
			} 
			break;
	}
	
	if ($affecteditems=="checkeditems")
	{
		$numofcheckedlids=count($checkedlids);		
		$editedlids=$checkedlids;
		
		$checkedlids=implode(", ", $checkedlids);
		$numofaffected=$numofcheckedlids;
		if ($numofcheckedlids==0)
		{	
			$dontexecutequery=true;
			$editortempopen=true;
			$error="no checked items";
			return false;
		}
		$wherequerypart="WHERE urlinfo.url_id IN ($checkedlids)";
		$tagwherequerypart=$wherequerypart;
		$limitquerypart = "LIMIT $numofcheckedlids";
		
		$taglimitquerypart=$limitquerypart; //? from orig lib masseditor
	}
	else if ($affecteditems=="thispageonly")
	{	$editedlids=$arr_lids;
		
		$numofeditedlids=count($editedlids);
		$numofaffected=$numofeditedlids;
		$checkedlids=implode(", ", $editedlids); //$pagelids
		$wherequerypart="WHERE urlinfo.url_id IN ($checkedlids)";
		
		$tagwherequerypart=$wherequerypart;
		$limitquerypart = "LIMIT $numofeditedlids";	
	}
	else if ($affecteditems=="allresults")
	{	if (!$url_organizer__allows_allresults_mass_edit_command)
		{	$dontexecutequery=true;
			$error="allresults command forbidden";
			return false;
		}
		if ($customsqlquery)
		{	$dontexecutequery=true;
			$error="allresults command forbidden with customsql";
			return false;
		}
		
		if ($typeofmassedit=="lister")
		{	$editedlids=$arr_lids;
			$limitquerypart="";
			global $urltables, $idequalsbit, $tagmapquery_part, $where, $findimages_querypart, $findtags_querypart, $andquerypart, $hidethistuff, $query_part2;
			$urltables="urlinfo";
			$tablequerypart="$urltables $tagmapquery_part ";			
			$wherequerypart = "$where $idequalsbit $findtags_querypart $andquerypart $hidethistuff $query_part2";
		}
		else
		{	$dontexecutequery=true;
			$error="this error should never be reached";
			return false;
		}
	}
	else
	{	$dontexecutequery=true;
		$error="ARGH";
		return false;
	}
	
	if ($dont_update_whenmodified)
	{
		if (!$editquery_part2)
		{	$whenmodified_querypart="whenmodified=whenmodified,";
		}
		else
		{	$whenmodified_querypart="";
		}
	}
	else
	{
		$whenmodified_querypart="whenmodified=$nowtimestamp,";
	}

	//Next, we handle the tags and other things that require additional fiddling beyond
	//what the ParseEditQuery function carries out on its own.
		
		
	
		//Start of big long extra data retrieval blurb
		if (
				($tags_changed && !$dontexecutequery) //tags
				|| ( $making_delete_queries && !$dontexecutequery)
						//outputting, but not executing, delete queries
			)
		//So, if any of the above is going on...
		//Then we have to retrieve all the affected files' ids, at least... and likely,
		//other details as well.
		{
			if ($tags_changed)
			{
				require ("../lib-tags.php");
				//we figure out what tagtypes are needed, and which tags are
				//going to be added, and which taken out.
				GetTagtypesAndtagsNeeded();
				
			}
			
			if ($making_tns || $updating_image_details || $move_actual_files || $update_locs_on_record)
			{
				if ($making_tns || $updating_image_details)
				{	require ("../lib-files.php");
					$needed_imfields=array("hasthumbnail", "showthumbnail");
					//$imageinfo=", imageinfo";
					//$join=" left join imageinfo on fileinfo.file_id = imageinfo.file_id";
				}
				$notif="edit exec";
				$needed_fields=array("file_id", "disk", "parentdirs", "filename", "ext");
				if ($move_actual_files || $update_locs_on_record)
				{	array_push($needed_fields, "paired");
					array_push($needed_fields, "pairedname");
					array_push($needed_fields, "itemtype");
				}
				if ($making_tns && $useprevdbthumbs)
				{	array_push($needed_fields, "prevdb_file_id");
				}
			}
			else
			{	$needed_fields=array("url_id");
			}
			
			foreach ($needed_fields as $field)
			{	$sqlfields .= "urlinfo.$field, ";
			}
			if ($making_tns || $updating_image_details)
			{
				foreach ($needed_imfields as $field)
				{	$sqlfields .= "ImageInfo.$field, ";
				}
				$sqlfields .= substr($imsqlfields, 0, -2);
			}
			$sqlfields=substr($sqlfields, 0, -2); // comma removed
			
			$thiswherequerypart=$wherequerypart;
			
			if ($affecteditems=="allresults")
			{	if ($url_organizer__allows_allresults_mass_edit_command)
				{
					$qtoissue="SELECT $sqlfields $needed_tagstrings from $tablequerypart $join $thiswherequerypart GROUP BY url_id";
				}
			}
			else if ($affecteditems=="thispageonly" || $affecteditems=="checkeditems")
			{	$qtoissue="SELECT $sqlfields $needed_tagstrings from urlinfo $thiswherequerypart ";
			}
		//	echo " $qtoissue  ";


			$queries_issued .= "$qtoissue<p>";

			$q_result = mysql_query($qtoissue,$handle) or die(mysql_error());
			
			$Insert_ImageDetails_querystart = "REPLACE INTO
	ImageInfo (file_id, width, height, area, aspectratio, reverse_aspectratio, wideortall, showthumbnail, hasthumbnail) VALUES ";
			$numofaffected=0;
			$numofdelids=0;
			$new_wherequerypart = "WHERE fileinfo.file_id IN (";
			$new_limit=0;
			$movemsg="<span class='error'>";
			
			while ($info = mysql_fetch_array($q_result) )
			{	$numofaffected++;
				foreach ($needed_fields as $var)
				{	${$var}=$info[$var];
				}
				
				if ($making_delete_queries)
				{	$delete_ids .= "$url_id, ";
					$numofdelids++;
				}
				
				if ($tags_changed)
				{
					foreach($arr_needed_tagstrings as $thistagstring)
					{	$dbtags[$url_id][$thistagstring]=$info[$thistagstring];
					}
					$tag_itemids[$url_id]=$url_id;
				}
				
			}//end of while loop
			
			if ($new_limit)	//If moving files, then, the limit number varies depending on how
					//many files were successfully moved...
			{
				$new_wherequerypart=substr($new_wherequerypart, 0, -2);
						
				$new_wherequerypart .= ")";
				$wherequerypart=$new_wherequerypart;
				
				$limitquerypart="LIMIT $new_limit";
				$numofaffected=$new_limit;
			}
			
			DisplayWithNotif($numofaffected, 2);
			
			//Start of delete-query portion
			if ($making_delete_queries)
			{	
				if ($numofdelids>0)
				{	$delete_ids=substr($delete_ids, 0, -2);	
					$deletequeries=CreateDeleteQueries($delete_ids, $numofdelids);

					$notif = "del queries created";
					
					$len=strlen($deletequeries);
					if ($len<2000)
					{
						$notifmsg2="Delete queries you can use manually:<p><pre>$deletequeries</pre>";
						DisplayWithNotif($notifmsg2, 4);
					}
					else
					{					
						if (!file_exists($localpath_for_delete_queries) )
						{	mkdir($localpath_for_delete_queries);
						}
						$res=time();
						$date = date("Y_m_d-H,i,s", $res);
						$delqueryfilename="$file_db_to_use-DELETE_Queries-$date.txt";
						$finalpath=$localpath_for_delete_queries . "/$delqueryfilename";
						OverwriteFile($finalpath, $deletequeries, true);
						$notifmsg="The delete queries are in this file:<p><a href=\"$finalpath\">$delqueryfilename</a>";
						DisplayWithNotif($notifmsg, 3);
					}
					
				}
				else
				{	//$error = "no ";
				}
				
			}
			//End of delete-query portion
		}
		//End of big long extra data retrieval blurb
		
		$editquery_part2=substr($editquery_part2, 2);
		$imagequery_part2=substr($imagequery_part2, 2);
		
		if ($affecteditems=="allresults")
		{	
			if (in_array("urlinfo", $affected_tables) || in_array("imageinfo", $affected_tables) )
			{	if ($new_limit)
				{	$edit_querytoissue = "UPDATE $tablequerypart SET $whenmodified_querypart $editquery_part2 $wherequerypart $limitquerypart";		
				}
				else
				{
					$edit_querytoissue = "UPDATE $tablequerypart SET $whenmodified_querypart $editquery_part2 $wherequerypart $limitquerypart";
				}
				//	echo "<p>Allrecords edit: $edit_querytoissue";
				$queries_issued .= "<p>$edit_querytoissue";
				$editqueriesissued .= "\n\n$edit_querytoissue";

				if (!$dontexecutequery)
				{	$notif="edit exec";
					$editortempopen=true;
					echo "edit_querytoissue: $edit_querytoissue ";
					$editquery_result = mysql_query($edit_querytoissue,$handle) or die(mysql_error());
					
					$numofaffected=mysql_affected_rows();
					DisplayWithNotif($numofaffected, 2);
				}
			}
		}
		else
		{	DisplayWithNotif($numofaffected, 2);
			
			foreach ($affected_tables as $table)
			{	
				if ($table=="urlinfo")
				{	$thisquerypart2=$editquery_part2;
				}
				else
				{	$thisquerypart2=$imagequery_part2;
				}
				$edit_querytoissue = "UPDATE $table SET $whenmodified_querypart $thisquerypart2 $wherequerypart $limitquerypart";
				
				//echo "<p>Editquerytoissue: $edit_querytoissue";
				$queries_issued .= "<p>$edit_querytoissue";
				
				$editqueriesissued .= "\n\n$edit_querytoissue";
				if (!$dontexecutequery)
				{	$notif="edit exec";
					$editortempopen=true;
					echo "edit_querytoissue: $edit_querytoissue ";
					$editquery_result = mysql_query($edit_querytoissue,$handle) or die(mysql_error());
				}
			}
		}
		
		if ($tags_changed && !$dontexecutequery)	//We also have to do more update queries to update the
			//tagstrings, not only the tags alone.
		{	
			if ($typeofmassedit=="adder")
			{	IssueTagMassEditQueries($tagwherequerypart, $taglimitquerypart);
			}
			else
			{	IssueTagMassEditQueries();
			}
			$notif="edit exec";
			$queries_issued .= $tqueries_issued;
		}		
		return true;
}
